/******** Paasche trade price index********/

/*Calcul de uv0*/

data Pp&refyear;
	set &source0;
	where t=&refyear;
	rename uv=uv0;
	drop v;
run;

/*ratio*/
proc sort data=&source0; by i j &sect &prod; run;
proc sort data=Pp&refyear; by i j &sect &prod;run;
data Pp1;
	merge Pp&refyear (keep= i j &sect &prod uv0) &source0    ;
	by i j &sect &prod;
run;
data Pp1;
	set Pp1;
	dp=uv/uv0;
	idp=1/dp; *Paasche formula is easily calculated with 1/dp dp= price variation; 
	lidp=log(idp);
	if dp=. then delete;
run;


/*calcul des poids*/
proc sort data=Pp1; by &i &sect t ; run; 
proc means data=Pp1 noprint;
	by &i &sect t;
	var v;
	output out=sumv sum=sumv;
run; 
proc sort data=Pp1; by &i &sect t ; run;
proc sort data=sumv; by &i &sect t; run;
data Pp2;
	merge sumv Pp1 ;
	by &i &sect t;
	w=v/sumv;
	if w=. then delete;
run;
proc sort data=Pp2; by &i &sect t; run;
proc means data=Pp2 noprint; 
	by &i &sect t;
	var v;
	output out=rate_Pp sum=sumPp;
run;
/*Calcule de l'indice de Paasche*/
proc sort data=Pp2; by &i &sect t; run;
proc means data=Pp2 noprint;
	by &i &sect t;
	var idp lidp;
	weight w;
	output out=IPP mean=IPp GIPp;
run;
data Pp3;
	set IPP;
	Pp=(1/IPp);
	GPp=exp(-GIPp);
	keep &i &sect t Pp GPp;
run;
data IP&baseyear;
	set Pp3;
	where t=&baseyear;
	keep &i &sect Pp GPp;
	rename Pp=PpB GPp=GPpB;
run; 
proc sort data=IP&baseyear; by &i &sect; run;
proc sort data=Pp3; by &i &sect; run; 
data  Pp&refyear&i&sect;
	merge IP&baseyear Pp3; 
	by &i &sect;
	Pp=(Pp/PpB)*100;
	GPp=(GPp/GPpB)*100;
	keep &i &sect t Pp GPp;
run;
